package org.agt.module.license.service.comment;

import jakarta.validation.Valid;
import org.agt.module.license.controller.admin.comment.vo.CommentListReqVO;
import org.agt.module.license.controller.admin.comment.vo.CommentSaveReqVO;
import org.agt.module.license.controller.admin.comment.vo.CommentTreeRespVO;
import org.agt.module.license.dal.dataobject.comment.CommentDO;

import java.util.List;

/**
 * 评论 Service 接口
 *
 * @author 管理员
 */
public interface CommentService {

    /**
     * 创建评论
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createComment(@Valid CommentSaveReqVO createReqVO);

    /**
     * 更新评论
     *
     * @param updateReqVO 更新信息
     */
    void updateComment(@Valid CommentSaveReqVO updateReqVO);

    /**
     * 删除评论
     *
     * @param id 编号
     */
    void deleteComment(Long id);

    /**
     * 获得评论
     *
     * @param id 编号
     * @return 评论
     */
    CommentDO getComment(Long id);

    /**
     * 获得评论列表
     *
     * @param listReqVO 查询条件
     * @return 评论列表
     */
    List<CommentDO> getCommentList(CommentListReqVO listReqVO);

    List<CommentTreeRespVO> getCommentTree(Long projectId, Boolean sort);

    List<CommentTreeRespVO> getLatestCommentList();
}